#----------------------------------------------------------------------------
# Ytube 		-    Youtube.com
# :	.chanset #chan +ytube
# :		!ytube [-] <>
# *     - -     ,
#     -  $maxres    
# :		
# :		anaesthesia #eggdrop@Rusnet
# :		http://egghelp.ru
#----------------------------------------------------------------------------

package require Tcl 	8.4
package require http	2.5

namespace eval ytube {
foreach p [array names ytube *] {catch {unset ytube ($p)}}

#----------------------------------------------------------------------------
#   
#----------------------------------------------------------------------------
	#    , ,   
	variable author			"anaesthesia"
	variable version		"01.00"
	variable date			"01-Aug-2008"
	variable unamespace		[namespace tail [namespace current]]

	#     (   )
	variable pubprefix 		{!}
	variable pubflag		{-|-}

	#   ()
	# pubcmd:_ "1 2 ..."
	#     ,      
	variable pub:ytube		"$unamespace"

	#    ,   
	variable msgprefix		{!}
	variable msgflag		{-|-}

	#       
	variable msg:ytube		${pub:ytube}

	#*      ,      
	#*     variable [pub|msg]:handler "string ..."

	#      
	#  $unick, $uhost, $uchan
	#  tcl ,    id   .
	variable requserid		{$uhost}
	
	#        id
	variable maxreqperuser	1

	#     
	variable maxrequests	5

	#   ,       ,  
	variable pause			15
	
	#  -
	#   "proxyhost.dom:proxyport"   ,  -  
	variable proxy 			{}

	#   ,   "" --  
	# ,         --  
	#  "no"        
	#         
	# (      ,     )
	variable flagactas		""
	
	#   ,   /   
	#          
	#        
	#      

	variable chflag			"$flagactas$unamespace"
	setudef  flag 			$chflag

#----------------------------------------------------------------------------
#   
#----------------------------------------------------------------------------
	#    --     
	#     
	variable logrequests	{'$unick', '$uhost', '$handle', '$uchan', '$ustr'}
	
	#     ,   --  
	#  $uchan & $unick
	variable pubsend		{PRIVMSG $uchan :}

	#     ,   --  
	#   $unick ($uchan == $unick)
	variable msgsend		{PRIVMSG $unick :}
	
	#    / 
	#  $unick
	variable errsend		{NOTICE $unick :}

	#      
	variable maxredir		3
	
	#    ,   30 
	variable timeout		30000

	#    
	variable err_ok			{  .}

	#     ,     
	#       
	variable err_fail		{     .      -.}

	#     
	variable err_queue_full	{           .   .}
	
	#       id
	variable err_queue_id	{    .}
	
	#          
	#   $timewait --  ,   
	#   
	variable err_queue_time {   .       $timewait .}
	
#----------------------------------------------------------------------------
#     
#----------------------------------------------------------------------------
	#   
	variable maxres		3

	#  
	variable 		reqqueue
	array unset 	reqqueue

	#  
	variable 		laststamp
	array unset		laststamp 
	variable		updinprogress	0
	variable		updatetimeout	60000

#---body---

	proc msg:ytube {unick uhost handle str} {
		pub:ytube $unick $uhost $handle $unick $str
		return
	}

	proc pub:ytube {unick uhost handle uchan str} {

		variable requserid
		variable fetchurl
		variable chflag
		variable flagactas
		variable errsend	
		variable maxres
		variable pubprefix
		variable pubsend
		variable msgsend
		variable unamespace
		variable ytype
		variable mpage
		variable query
		variable logrequests

		set id [subst -nocommands $requserid]
		set prefix [subst -nocommands $errsend]

		if {$unick ne $uchan} {if {![channel get $uchan $chflag] ^ $flagactas eq "no" } {return}}

		set why [queue_isfreefor $id]
		if {$why != ""} {lput puthelp $why $prefix ; return}
		set query ""

#---
		set ustr [string trim [tolow $str]]

		if {[regexp -nocase -- {^-(\d+)} $ustr -> mpg]} {regsub -- {-\d+\s+} $ustr "" ustr ; set mpage $mpg ; set ytype 1} {set mpg 1; set mpage 1 ; set ytype 0}
		if {$mpage > 20} {set pg "&page=[expr {$mpage / 20}]" ; set mpage [expr {($mpage % 20) > 0 ? ($mpage % 20) : 1}]} {set mpage [expr {$mpage > 0 ? $mpage : 1}] ; set pg ""}
 			
		if {![chkrus $ustr]} {
			set fetchurl "http://www.youtube.com/"
			set fparm "results?search_type=search_videos&search_sort=relevance&search_query=[uenc $ustr]&search=Search$pg"
        } {
			set fetchurl "http://ru.youtube.com/"
			set fparm "results?search_type=search_videos&search_sort=relevance&search_query=[uenc $ustr]&search=Search$pg"
		}

		::http::config -useragent "Mozilla/5.0 (X11; U; Linux i686; ru-RU; rv:1.8.1) Gecko/2006101023 Firefox/2.0"

			if {[string is space $ustr]} {
				set prefix [subst -nocommands $msgsend]
				lput puthelp "\002\002: ${pubprefix}${unamespace} \[-\] <> ::    youtube.com" $prefix		
				return
			}

		if {$logrequests ne ""} {set logstr [subst -nocommands $logrequests] ; lput putlog $logstr "$unamespace: "}
		if {[queue_add "${fetchurl}${fparm}" $id "[namespace current]::ytube:parser" [list $unick $uhost $uchan $ustr $mpg]]} {
			variable err_ok ; if {$err_ok ne ""} {lput puthelp "$err_ok" $prefix}
		} {
			variable err_fail ; if {$err_fail ne ""} {lput puthelp "$err_fail" $prefix}
		}

	return
	}

#---parser
	proc ytube:parser {errid errstr body extra} {
		upvar $errid lerrid $errstr lerrstr $body lbody $extra lextra

		variable err_fail
		variable pubsend
		variable msgsend
		variable errsend
		variable maxres
		variable mpage
		variable ytype

		foreach {unick uhost uchan ustr mpg} $lextra {break}
		if {$lerrid ne {ok}} {lput putserv [subst -nocommands $err_fail] [subst -nocommands $errsend] ; return}
		if {$uchan eq $unick} {set prefix [subst -nocommands $msgsend]} {set prefix [subst -nocommands $pubsend]}

		if {[info exists ::sp_version]} {set str [encoding convertfrom utf-8 $lbody]} {set str $lbody}

#----------------------------------------------------------------------------
##---parser-specific------
#----------------------------------------------------------------------------
		set results 0 ; set out "" ; set ct ""; set m "" ; set t "" ; if {$mpg == 0} {set mpg 1}
		regsub -all "\t|\n|\r|\v" $str "" str
		regsub -all -nocase {(?:<b>|</b>|<em>|</em>)} $str "\002" str
 		if {[string match "*<head><body> This object may be found*" $str]} {regexp -- {youtube(.*?)/} $str -> sugg ; lput putserv "\002$ustr\002  .  : \002$sugg\002" $prefix}
		if {![regexp -- {<div class="name">.*?</span>(.*?)<strong>.*?</strong>.*?<strong>([,\.0-9]{1,})</strong>} $str -> t m]} {set m "YouTube" ; set t "."}
		regsub -all -nocase -- "<span.*?>" $str "" str
		regsub -all -nocase -- "</span>" $str "" str
		if {$m != ""} {set out "\[$m\] :: "}

		if {$ytype} {set mr 20} {set mr [expr {$maxres - 1}]}
		while {$results <= $mr} {

			regexp -nocase -- {vlshortTitle">.+?<a href="/watch.v=(.+?)".+?title=".+?">(.+?)</a>} $str -> cid desc
			if {[regexp -nocase -- {<div  class="vldesc">(.+?)</div>} $str -> ldesc]} {regsub -all -- "<.*?>" $ldesc "" ldesc ; set ldesc [string map -nocase {"()" "" "()" "" "(more)" "" "(less)" ""} $ldesc]}
			if {[regexp -nocase -- {<div class="vladded">(.+?)</div>} $str -> vadd]} {regsub -all -- "<.*?>" $vadd "" vadd ; set vadd [string map {"Added:" "" ":" ""} $vadd]}
			regexp -nocase -- {<div class="runtime">(.+?)</div} $str -> ct
			regexp -nocase -- {<div class="vlcategory">.*?<a href=.*?>(.*?)</a>} $str -> cat
			if {[regexp -nocase -- {<div class="clearL">.*?</div>(.+?)<br/>} $str -> vi]} {regsub -all -- "<.*?>" $vi "" vi ; set vi [string map -nocase {"Views:" "" ":" ""} $vi]} {set vi "n/a"} 
			regexp -nocase -- {<img class="ratingVS.*?alt="(.+?)"} $str -> rate
        	regsub -nocase -- {vlshortTitle">.*?<a.+?href=.+?</a>.+?<div class="runtime".+?</div} $str "" str

			if {![info exists desc]} {
				if {$results == 0} {
					regexp -- {<div class="marT10">(.+?)</div></div>} $str -> er ; regsub -- {</a></div>} $er "? " er ; regsub -all -- {<(.+?)>} $er { } er
					lput putserv "[sconv [string trim [sspace $er]]]" $prefix
					return
				} {break}
        	} 

			if {[info exists desc]} {set desc [string trim [string range $desc 0 100]]}
			if {[info exists ded]} {append desc "\017 ([string trim ${ct}])"}
			if {![chkrus $ustr]} {set link "http://www.youtube.com/watch?v=${cid}"} {set link "http://ru.youtube.com/watch?v=${cid}"}
			append out "[sconv ${desc}]\017 \@ \037\00312${link}\037\017 :: "
 			incr results

			if {$ytype && $results == $mpage} {lput putserv "\[$mpg/$m\] :: \00305[sconv ${desc}]\003 :: [sconv [sspace ${ldesc}]] :: \[\002T\002:[string trim ${ct}]/\002R\002:$rate/\002V\002:[string trim $vi]/\002A\002:[sspace [string trim $vadd]]/\002[sspace [sconv $cat]]\002\] \@ \037\00312${link}\037" $prefix ; break}

			unset link ; unset desc ; set ct ""
		} ;#while

		if {!$ytype} {lput putserv "$out" $prefix}

	return
	}		
#----------------------------------------------------------------------------
##---end-parser------
#----------------------------------------------------------------------------

	proc sspace  {strr} {return [string trim [regsub -all {[\t\s]+} $strr { }]]}
	proc tolow   {strr} {return [string tolower [string map {                                                                 } $strr]]}
	proc chkrusl {strr} {if {[lsearch -exact {                                                                 } $strr] > -1} {return 1} {return 0}}

	proc chkrus {strr} {
  	set len [string length $strr] ; set cnt 0
  		while {$cnt < $len} {if {[chkrusl [string index $strr $cnt]]} {return 1} ; incr cnt}
  	return 0
	}

	proc uenc {strr} {
	set str ""
		foreach byte [split [encoding convertto utf-8 $strr] ""] {scan $byte %c i ; if {[string match {[%<>"]} $byte] || $i < 65 || $i > 122} {append str [format %%%02X $i]} {append str $byte}}
	return [string map {%3A : %2D - %2E . %30 0 %31 1 %32 2 %33 3 %34 4 %35 5 %36 6 %37 7 %38 8 %39 9 \[ %5B \\ %5C \] %5D \^ %5E \_ %5F \` %60} $str]
    }

	proc sconv {strr} {
	set escapes {
        &nbsp; \x20 &quot; \x22 &amp; \x26 &apos; \x27 &ndash; \x2D
        &lt; \x3C &gt; \x3E &tilde; \x7E &euro; \x80 &iexcl; \xA1
        &cent; \xA2 &pound; \xA3 &curren; \xA4 &yen; \xA5 &brvbar; \xA6
        &sect; \xA7 &uml; \xA8 &copy; \xA9 &ordf; \xAA &laquo; \xAB
        &not; \xAC &shy; \xAD &reg; \xAE &hibar; \xAF &deg; \xB0
        &plusmn; \xB1 &sup2; \xB2 &sup3; \xB3 &acute; \xB4 &micro; \xB5
        &para; \xB6 &middot; \xB7 &cedil; \xB8 &sup1; \xB9 &ordm; \xBA
        &raquo; \xBB &frac14; \xBC &frac12; \xBD &frac34; \xBE &iquest; \xBF
        &Agrave; \xC0 &Aacute; \xC1 &Acirc; \xC2 &Atilde; \xC3 &Auml; \xC4
        &Aring; \xC5 &AElig; \xC6 &Ccedil; \xC7 &Egrave; \xC8 &Eacute; \xC9
        &Ecirc; \xCA &Euml; \xCB &Igrave; \xCC &Iacute; \xCD &Icirc; \xCE
        &Iuml; \xCF &ETH; \xD0 &Ntilde; \xD1 &Ograve; \xD2 &Oacute; \xD3
        &Ocirc; \xD4 &Otilde; \xD5 &Ouml; \xD6 &times; \xD7 &Oslash; \xD8
        &Ugrave; \xD9 &Uacute; \xDA &Ucirc; \xDB &Uuml; \xDC &Yacute; \xDD
        &THORN; \xDE &szlig; \xDF &agrave; \xE0 &aacute; \xE1 &acirc; \xE2
        &atilde; \xE3 &auml; \xE4 &aring; \xE5 &aelig; \xE6 &ccedil; \xE7
        &egrave; \xE8 &eacute; \xE9 &ecirc; \xEA &euml; \xEB &igrave; \xEC
        &iacute; \xED &icirc; \xEE &iuml; \xEF &eth; \xF0 &ntilde; \xF1
        &ograve; \xF2 &oacute; \xF3 &ocirc; \xF4 &otilde; \xF5 &ouml; \xF6
        &divide; \xF7 &oslash; \xF8 &ugrave; \xF9 &uacute; \xFA &ucirc; \xFB
        &uuml; \xFC &yacute; \xFD &thorn; \xFE &yuml; \xFF
	}
	set strr [string map $escapes [join [lrange [split $strr] 0 end]]] 
    regsub -all -- {\[} $strr "\\\[" strr
    regsub -all -- {\]} $strr "\\\]" strr
    regsub -all -- {\(} $strr "\\\(" strr
    regsub -all -- {\)} $strr "\\\)" strr
  	regsub -all -- {&#([[:digit:]]{1,5});} $strr {[format %c [string trimleft "\1" "0"]]} strr
 	regsub -all -- {&#x([[:xdigit:]]{1,4});} $strr {[format %c [scan "\1" %x]]} strr
 	regsub -all -- {&#?[[:alnum:]]{2,7};} $strr "" strr
	return [subst -novariables $strr]
	}

	proc lput {cmd str {prefix {}} {maxchunk 420}} {
	set buf1 "" ; set buf2 [list]
		foreach word [split $str] {append buf1 " " $word ; if {[string length $buf1]-1 >= $maxchunk} {lappend buf2 [string range $buf1 1 end] ; set buf1 ""}}
		if {$buf1 != ""} {lappend buf2 [string range $buf1 1 end]}
		foreach line $buf2 {$cmd $prefix$line}
	return
	}

	proc queue_isfreefor {{id {}}} {

		variable reqqueue
		variable maxreqperuser
		variable maxrequests
		variable laststamp
		variable pause
		variable err_queue_full	
		variable err_queue_id
		variable err_queue_time 

		if {[info exists laststamp(stamp,$id)]} {
			set timewait [expr {$laststamp(stamp,$id) + $pause - [unixtime]}]
			if {$timewait > 0} {return [subst -nocommands $err_queue_time]}			
		}
		if {[llength [array names reqqueue -glob "*,$id"]] >= $maxreqperuser} {return $err_queue_id}
		if {[llength [array names reqqueue]] >= $maxrequests} {return $err_queue_full}		
	return
	}

	proc queue_add {newurl id parser extra {redir 0}} {
		variable reqqueue
		variable proxy
		variable timeout
		variable laststamp
		variable query

		::http::config -proxyfilter "[namespace current]::queue_proxy"

		if {$query eq ""} {
			if {![catch {set token [::http::geturl $newurl -command [namespace current]::queue_done -binary true -timeout $timeout]} errid]} {					
			set reqqueue($token,$id) [list $parser $extra $redir] ; set laststamp(stamp,$id) [unixtime]
			} {return false}
		} {
			if {![catch {set token [::http::geturl $newurl -command [namespace current]::queue_done -binary true -timeout $timeout -query ${query}]} errid]} {					
			set reqqueue($token,$id) [list $parser $extra $redir] ; set laststamp(stamp,$id) [unixtime]
			} {return false}
		}
	return true
	}

	proc queue_proxy {url} {
		variable proxy

		if {$proxy ne {}} {return [split $proxy {:}]}		
		return [list]
	}
	
	proc queue_done {token} {
		upvar #0 $token state
		variable reqqueue
		variable maxredir
		variable fetchurl

		set errid  	[::http::status $token]
		set errstr 	[::http::error  $token]		
		set	id [array names reqqueue "$token,*"]
		foreach {parser extra redir} $reqqueue($id) {break}
		regsub -- "^$token," $id {} id
	
		while (1) {
			if {$errid == "ok" && [::http::ncode $token] == 302} {
				if {$redir < $maxredir} {			
					array set meta $state(meta)
					if {[info exists meta(Location)]} {queue_add "$fetchurl$meta(Location)" $id $parser $extra [incr redir]; break}
				} {set errid "error" ; set errstr "Max. redir."}
			} 
			if {[catch {$parser {errid} {errstr} {state(body)} {extra}} errid]} {lput putlog $errid "[namespace current] "}
		break
		}			
		array unset reqqueue "$token,*"
		::http::cleanup $token
	return
	}

#--- 
	proc queue_clear_stamps {} {

		variable laststamp
		variable timeout
		variable timerID

		set curr [expr {[unixtime] - 2 * $timeout / 1000}];
		foreach {id} [array names laststamp] {if {$laststamp($id) < $curr} {array unset laststamp $id}}		
		set timerID [timer 10 "[info level 0]"]
	}

	proc cmdaliases {{action {bind}}} {
		foreach {bindtype} {pub msg dcc} {
			foreach {bindproc} [info vars "[namespace current]::${bindtype}:*"] {
				variable "${bindtype}prefix" ; variable "${bindtype}flag"			
				foreach {alias} [set $bindproc] {catch {$action $bindtype [set ${bindtype}flag] [set ${bindtype}prefix]$alias $bindproc}}				
			}
		}	
	return
	}

#---init
	if {[info exists timerID]} {catch {killtimer $timerID} ; catch {unset timerID}}	
	[namespace current]::queue_clear_stamps
	[namespace current]::cmdaliases
#---log
  	variable sfil [lindex [split [info script] "/"] end]
  	variable modf [clock format [file mtime [info script]] -format "%d-%b-%Y : %H:%M:%S"]
	if {[info exists ::sp_version]} {putlog "[namespace current] v$version (suzi_$sp_version) :: file:$sfil / rel:\[$date\] / mod:\[$modf\] :: by $author :: loaded."} {putlog "[namespace current] v$version :: file:$sfil / rel:\[$date\] / mod:\[$modf\] :: by $author :: loaded."}

} ;#end










